#ifndef _STUDENT_H
#define _STUDENT_H

#include <string>
#include <fstream>

#include "Course.h"

using namespace std;

class Student
{ // version 2
public:
// constructors, destructor
   explicit Student( int aIdNum=0 );
   Student( const Student& rhs );
   ~Student() {  delete[] sCourses;  };
// copy assignement
   Student& operator=( const Student& rhs );
// getters
   unsigned int getIdNum() const { return sIdNum; }
   const char* getSurname() const { return sSurname; }
   const char* getFirstname() const { return sFirstname; }
   unsigned int getWH() const {  return sWH;  }
   unsigned int getNoOfCourses() const { return sNoOfCourses; }
   const Course::CourseKey* getCourses() const { return sCourses; }
// setters
   void setIdNum( int aIdNum );
   void setSurname( string aSurname );
   void setFirstname( string aFirstname );
   void clearCourses() {  sNoOfCourses = 0;  sWH = 0;  }
// 1 Course methods
   bool find1Course( const string& code ) const
   {  return ( findNdx(code) >= 0 );  };
   void add1Course( const Course& oneCourse );
   void delete1Course( const Course& oneCourse );
// other methods
   void swap( Student& rhs );
   void readPartFromText( istream& tin );
   void save( ostream& bout ) const;
   void load( istream& bin );
   void display( ostream& tout );
private:
   enum { sNameSz = 20 };
   enum { sIncr = 3 };
   unsigned int       sIdNum;        //  
   char               sSurname[sNameSz];
   char               sFirstname[sNameSz]; 
   unsigned int       sWH;           //   
   unsigned int       sNoOfCourses;  //   
                                     // 
   Course::CourseKey* sCourses; 
   unsigned int       sReserved;

   unsigned int countTabs( string aLine );
   int findNdx( const string& code ) const;
   void insert1Course( const Course::CourseKey& aCode );
   void erase1Course( int ndx );
}; // Student

typedef Student* PStudent;

bool operator!=( const Student& lhs, const Student& rhs )
{  return (lhs.getIdNum() != rhs.getIdNum());  }

bool operator==( const Student& lhs, const Student& rhs )
{  return !(lhs != rhs);  }

struct StudentXptn
{ // version 2
   enum { allocFailed, negIdNum, //nonPosIncr,
          incomplete,
          fileNotOpen, cannotRead, cannotWrite };
   unsigned int objKey;
   char         methodName[100];
   int          errorCode;
   char         errStrVal[100];
   int          errIntVal;
   StudentXptn( int obk, const char* mn, int ec, const char* sv="" )
      :  objKey( obk ),  errorCode( ec )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      strncpy( errStrVal, sv, 99 );  errStrVal[99] = '\0';  }
   StudentXptn( int obk, const char* mn, int ec, int ev )
      :  objKey( obk ),  errorCode( ec ),  errIntVal( ev )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';  }
}; // StudentXptn

#endif // _STUDENT_H
